Subject: Re: [urn] discard q-component

From: Peter Saint-Andre <[email-masked]>
Date: Sun, 1 Nov 2015 16:35:40 -0700

On 10/31/15 10:01 AM, John C Klensin wrote:

> I think we are at a fork in the virtual road.   On one path, we
> just figure out how to make separate q- and r-components work,
> making sure that 2141bis contains appropriate qualifying
> language.  On the other, we take a more extreme version of
> Keith's "URNA" proposal, depreciate URNs as having gotten just
> much too confused and now representing a bad combination of
> incompatible concepts, and then start efforts to define a new
> set of typologies for generic name-type things that may or may
> not define or point to resources.   Or we can stand in the road,
> looking at the fork, and either jumping from one foot to the
> other or running in small circles until some truck comes along
> and puts an end to the discussion.

I say we take the first path: let's make q- and r-components work and 
finish 2141bis.

Peter

---

From: Andrew Newton <[email-masked]>
Date: Mon, 2 Nov 2015 00:05:01 -0500

On Wed, Oct 28, 2015 at 11:39 PM, John C Klensin <[email-masked]> wrote:
>
> specialChar1 and specialChar2 should be chosen to minimize the
> likelihood of collisions with URL queries.  I'd guess that most
> of the characters other than left parentheses, left brackets,
> and single-quote listed for <sub-delims> in 3986 would be
> reasonable candidates.  To the extent to which queries
> ordinarily take the form
>    ? [SP] phrase ...
> or
>    ? [SP} keyword = value ...
> forms like
>    ?<selected-sub-delim>
> are just not going to be an issue.

3986 lists:

gen-delims  = ":" / "/" / "?" / "#" / "[" / "]" / "@"

      sub-delims  = "!" / "$" / "&" / "'" / "(" / ")"
                  / "*" / "+" / "," / ";" / "="

']' is in gen-delims, and ')' is in sub-delims.

-andy

---

From: John C Klensin <[email-masked]>
Date: Mon, 02 Nov 2015 08:02:09 -0500

--On Monday, November 02, 2015 00:05 -0500 Andrew Newton
<[email-masked]> wrote:

>> likelihood of collisions with URL queries.  I'd guess that
>> most of the characters other than left parentheses, left
>> brackets, and single-quote listed for <sub-delims> in 3986
>> would be reasonable candidates.  To the extent to which
>> queries ordinarily take the form
>>    ? [SP] phrase ...
>> or

Andy,

I deliberately did not propose specific delimiters.  The two I
did choose were because they seems to made good illustrations of
what I was talking about, but not either proposals or examples.
Indeed, I knew that "]" was on the gen-delims list and used it
in the hope of kicking off a discussion of delimiters if the WG
decided it preferred a model of 

   r-string = "?" specialChar2 r-component
   q-string = "?" specialChar1 q-component

to

   r-string = "?" "?" r-component
   q-string = "?" <any-ASCII-graphic-or-space> q-component

or

   q-string = "?" <pchar> q-component

(I think we are at one of the latter two or something between
them in 2141bis-14)

Thanks for touching off the "which delimiters" discussion even
though I think we should resolve the other one first: if we
prefer sticking with single and double question marks, the
delimiter choice is a non-issue.

    john

---

From: Andrew Newton <[email-masked]>
Date: Mon, 2 Nov 2015 10:14:00 -0500

> delimiter choice is a non-issue.

Sorry, that subtly of the proposal was lost on me. I'll blame it on
jet lag or lack of caffeine, because it certainly can't be that
navigating the discussions on this list are in any way difficult. :)

So let me summarize what I think the issue is: we have not yet been
able to get '??' to work right in the ABNF. And therefore we have
several thought experiments which have ranged from just noting the
issue in the prose to trying harder to throwing everything we've done
so far away. Do I have that right?

If I do, then here is the chair guidance: let the document authors
figure it out, and the rest of us just need to live with it. To me
this seems like a small matter that does not need endless discussion.
You and Peter can thumb wrestle or throw darts or whatever, and if you
decide to try to get the ABNF 100% perfect (and good luck with that, I
think I know the outcome), so be it. If you decide that an ABNF
comment or prose comment or both are appropriate, so be it. Or if you
decide that special character delimiters are needed, pick two and so
be it (and btw, I hate the two you picked but if that's where you want
to go, I'll live with my hate of ')' and ']').

I'm not trying to sound harsh to any discussion participants here, but
from my perspective this is a small matter we should trust to the
judgement of the document authors.

-andy

---

From: John C Klensin <[email-masked]>
Date: Mon, 02 Nov 2015 10:49:32 -0500

--On Monday, November 02, 2015 10:14 -0500 Andrew Newton
<[email-masked]> wrote:

> Sorry, that subtly of the proposal was lost on me. I'll blame
> it on jet lag or lack of caffeine, because it certainly can't
> be that navigating the discussions on this list are in any way
> difficult. :)

I've noticed the problem and, unlike you, at least can't blame
jet lag :-(

> So let me summarize what I think the issue is: we have not yet
> been able to get '??' to work right in the ABNF. And therefore
> we have several thought experiments which have ranged from
> just noting the issue in the prose to trying harder to
> throwing everything we've done so far away. Do I have that
> right?

I think that is right, although, IMO, the ABNF difficulties are
just a symptom of some more basic conceptual problems, with the
ordering of r- versus q-components being another symptom.  

> If I do, then here is the chair guidance: let the document
> authors figure it out, and the rest of us just need to live
> with it. To me this seems like a small matter that does not
> need endless discussion. You and Peter can thumb wrestle or
> throw darts or whatever, and if you decide to try to get the
> ABNF 100% perfect (and good luck with that, I think I know the
> outcome), so be it. If you decide that an ABNF comment or
> prose comment or both are appropriate, so be it. Or if you
> decide that special character delimiters are needed, pick two
> and so be it (and btw, I hate the two you picked but if that's
> where you want to go, I'll live with my hate of ')' and ']').

Part of my "symptom of conceptual problem" concern is that I
think Keith (and maybe others) are convinced that we need to
rather precisely define the boundary between the appropriate
content for q-components and r-components (or get rid or one or
both).  I don't think so and maybe I misunderstand what Keith is
asking for -- see long note I just sent -- but, unlike some
details of syntax, I think decisions at that level need to be
made by the WG, not by Peter and myself.

For the record, I hate the idea of making syntax decisions based
on what is easy to express in ABNF rather than what works well
for the application, but I could say (and have said) the same
thing about what works well for UNRs in the context of 3986.
 
> I'm not trying to sound harsh to any discussion participants
> here, but from my perspective this is a small matter we should
> trust to the judgement of the document authors.

I'd be ok with going off with Peter and making a decision, but
see above.

BTW, the reason I selected ")" and "]" for those examples was
that I hate them and hope that others would hate them enough to
force a conversation.   If left to my own devices, I guarantee
you won't see them in a final proposal (and that I'll fight
Peter if he likes them) :-)

thanks,
    john

---

From: Keith Moore <[email-masked]>
Date: Tue, 3 Nov 2015 18:23:37 -0500

> judgement of the document authors.

I agree that this should not require a significant discussion.  ABNF is 
entirely sufficient for this purpose, and it is indeed possible to write 
relatively succinct ABNF that unambiguously recognizes whatever syntax 
for r- and q- components we decide on.   I'm happy to let the authors do 
it, but if they can't, I'm sure myself or someone else can.

There are far more important issues at hand than how to represent the 
syntax in ABNF, and focusing on the ABNF seems like an unhelpful 
distraction.

Keith

---

From: Keith Moore <[email-masked]>
Date: Tue, 3 Nov 2015 18:32:27 -0500

On 11/02/2015 10:49 AM, John C Klensin wrote:
> both).

I am indeed convinced that we need to rather precisely define the 
boundary between appropriate content for q-components and 
r-components.   I thought it was already understood and agreed to that 
the r-component needed to exist because there was a need to clearly 
separate the parameters passed to resolution services (r-component) from 
those passed to resources (q-component).   The cases in which both will 
be used with the same base URN at the same time are IMO significant - 
basically any time it is desired to use a URN to name a service which 
takes parameters that are passed via a URL query.

Getting rid of either r-component or q-component would IMO be a step 
backward.   If we did that I'd have to wonder what value we were adding 
over RFC 2141.

> I don't think so and maybe I misunderstand what Keith is

This is indeed a distinct issue from syntax, so it's important to not 
confuse the two issues.   The choice of syntax is a relatively minor 
issue.   It doesn't matter much what the syntax for r-components and 
q-components is as long as that syntax is unambiguous, and as long as 
the way that q-components are transferred to URLs (when applicable) is 
clear and likely to be implemented correctly.

Keith